Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
Botan::EMSA Class Referenceabstract

`#include <emsa.h>`

Inheritance diagram for Botan::EMSA:

## Public Member Functions
virtual EMSA * | clone ()=0
virtual secure_vector< uint8_t > | encoding_of (const secure_vector< uint8_t > &msg, size_t output_bits, RandomNumberGenerator &rng)=0
virtual secure_vector< uint8_t > | raw_data ()=0
virtual void | update (const uint8_t input[], size_t length)=0
virtual bool | verify (const secure_vector< uint8_t > &coded, const secure_vector< uint8_t > &raw, size_t key_bits)=0
virtual | ~EMSA ()=default

## Detailed Description

EMSA, from IEEE 1363s Encoding Method for Signatures, Appendix

Any way of encoding/padding signatures

Definition at line 21 of file emsa.h.

## Constructor & Destructor Documentation

virtual Botan::EMSA::~EMSA | ( |  | ) |
| virtual default

## Member Function Documentation

virtual EMSA* Botan::EMSA::clone | ( |  | ) |
| pure virtual

Returns
  a new object representing the same encoding method as *this

Implemented in Botan::ISO_9796_DS3, Botan::EMSA_PKCS1v15_Raw, Botan::ISO_9796_DS2, Botan::PSSR, Botan::EMSA_PKCS1v15, Botan::EMSA_X931, Botan::EMSA1, and Botan::EMSA_Raw.

virtual secure_vector<uint8_t> Botan::EMSA::encoding_of | ( | const secure_vector< uint8_t > & | msg,
|  | size_t | output_bits,
|  | RandomNumberGenerator & | rng
| ) |  |
| pure virtual

Return the encoding of a message

Parameters

  msg | the result of raw_data()
  output_bits | the desired output bit size
  rng | a random number generator

Returns
  encoded signature

Implemented in Botan::EMSA_PKCS1v15_Raw, and Botan::EMSA_PKCS1v15.

virtual secure_vector<uint8_t> Botan::EMSA::raw_data | ( |  | ) |
| pure virtual

Returns
  raw hash

Implemented in Botan::EMSA_PKCS1v15_Raw, and Botan::EMSA_PKCS1v15.

virtual void Botan::EMSA::update | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| pure virtual

Add more data to the signature computation

Parameters

  input | some data
  length | length of input in bytes

Implemented in Botan::EMSA_PKCS1v15_Raw, and Botan::EMSA_PKCS1v15.

virtual bool Botan::EMSA::verify | ( | const secure_vector< uint8_t > & | coded,
|  | const secure_vector< uint8_t > & | raw,
|  | size_t | key_bits
| ) |  |
| pure virtual

Verify the encoding

Parameters

  coded | the received (coded) message representative
  raw | the computed (local, uncoded) message representative
  key_bits | the size of the key in bits

Returns
  true if coded is a valid encoding of raw, otherwise false

Implemented in Botan::EMSA_PKCS1v15_Raw, and Botan::EMSA_PKCS1v15.

The documentation for this class was generated from the following file:

- src/lib/pk_pad/emsa.h